﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Practices.Prism.ViewModel;
using mosquitto.net;

namespace Module1.ViewModels
{
    public class MessageViewModel :NotificationObject
    {
        public MessageViewModel()
        {
            _m = new Message();
            Date = DateTime.Now;
        }

        public MessageViewModel(Message m)
        {
            _m = m;
            Date = DateTime.Now;
        }

        public int Mid
        {
            get { return _m.Mid; }
        }

        public string Qos
        {
            get { return _m.Qos.ToString(); }
        }

        public string Topic { get { return _m.Topic; } }

        public string Payload
        {
            get
            {
                return Message.ToAscii(_m.Payload);
            } 
        }

        public DateTime Date { get; private set; }

        private Message _m;
        
    }
}
