﻿using System.Collections.ObjectModel;
using Microsoft.Practices.Prism.Commands;
using Microsoft.Practices.Prism.ViewModel;
using mosquitto.net;

namespace Module1.ViewModels
{
    public class SubscriptionViewModel : NotificationObject
    {
        public SubscriptionViewModel()
        {
            Messages.Add(new MessageViewModel(new Message(){Mid=1000,Qos=Qos.Confirmation,Payload=new byte[2]{65,66}}));
        }

        public SubscriptionViewModel(string topic, bool canUnsubscribe = true):this()
        {
            Messages.Clear();
            CanUnsubscribe = canUnsubscribe;
            _topic = topic;
            Messages.CollectionChanged += MessagesCollectionChanged;
            
        }

        public string Topic
        {
            get { return  _topic; }
        }

        public string Title { get { return string.Format("{0} ({1})", _topic, Count); } }

        public int Count { get { return Messages.Count; } }

        public ObservableCollection<MessageViewModel> Messages
        {
            get { return _messages; }
            set { _messages = value; }
        }

        public bool CanUnsubscribe
        {
            get { return _canUnsubscribe; }
            set
            {
                _canUnsubscribe = value;
                RaisePropertyChanged(()=>CanUnsubscribe);
            }
        }

        void MessagesCollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            RaisePropertyChanged(() => Messages);
            //RaisePropertyChanged(() => Count);
            RaisePropertyChanged(() => Title);
        }


        private bool _canUnsubscribe;
        private readonly string _topic;
        private ObservableCollection<MessageViewModel> _messages = new ObservableCollection<MessageViewModel>();
        
    }
}
