﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NUnit.Framework;
using mosquitto.net;

namespace ClientTests
{
    [TestFixture]
    public class ArgumentsTest
    {
        private readonly int _id = System.Diagnostics.Process.GetCurrentProcess().Id;
        [Test]
        public void Test0001([Values("mqtt://test.mosquitto.org:1883/$SYS/+/+/+")]string uri)
        {
            mosquitto.net.Arguments args = new Arguments(new Uri(uri),_id );
            NUnit.Framework.Assert.AreEqual(args.Host, "test.mosquitto.org");
            NUnit.Framework.Assert.AreEqual(args.Port, 1883);
            NUnit.Framework.Assert.AreEqual(args.Topic, "$SYS/+/+/+");
        }

        [Test]
        public void Test0002([Values("mqtt://test.mosquitto.org:1883/$SYS/+/+/+?keepalive=100&qos=2&username=Hello&password=Hello&debug=true&clean=false&prefix=prefix")]string uri)
        {
            mosquitto.net.Arguments args = new Arguments(new Uri(uri), _id);
            NUnit.Framework.Assert.AreEqual(args.Host, "test.mosquitto.org");
            NUnit.Framework.Assert.AreEqual(args.Port, 1883);
            NUnit.Framework.Assert.AreEqual(args.Topic, "$SYS/+/+/+");
            NUnit.Framework.Assert.AreEqual(args.KeepAlive, 100);
            NUnit.Framework.Assert.AreEqual(args.Qos, Qos.Handshake);
            NUnit.Framework.Assert.AreEqual(args.Username, "Hello");
            NUnit.Framework.Assert.AreEqual(args.Password, "Hello");
            NUnit.Framework.Assert.AreEqual(args.Debug, true);
            NUnit.Framework.Assert.AreEqual(args.Clean, false);
            NUnit.Framework.Assert.AreEqual(args.Id, string.Format("prefix_{0}",_id));
        }
    }
}
