﻿using System.Text;

namespace mosquitto.net
{
    /// <summary>
    /// A MQTT message
    /// </summary>
    public struct Message
    {
        /// <summary>
        /// The message id
        /// </summary>
        public ushort Mid;
        /// <summary>
        /// The payload
        /// </summary>
        public byte[] Payload;
        /// <summary>
        /// The Quality of Service
        /// </summary>
        public Qos Qos;
        /// <summary>
        /// Message is retained
        /// </summary>
        public bool Retain;
        /// <summary>
        /// Topic of message
        /// </summary>
        public string Topic;

        public static string ToAscii(byte[] payload)
        {
            return Encoding.ASCII.GetString(payload);
        }
    }
}