#pragma once
#include <string>
#include <functional>
#include "qos.h"
#include "uri.h"
using namespace std;
namespace mosq
{
	
	class arguments
	{
	public:
		arguments(int pid);
		arguments(const uri& u, int pid);
		~arguments(void);

		void port(int port)		{ _port = port;}
		int port() const		{ return _port;}

		void host(const string& host)	{ _host = host;}
		string host()			{ return _host;}

		void topic(const string& topic) {_topic = topic;}
		string topic() const	{ return _topic;}

		void username(const string& username) { _username = username;}
		string username() const	{ return _username;}

		void password(const string& password) { _password = password;}
		string password() const	{ return _password;}

		int keepalive() const {return _keepalive;}
		void keepalive(int ka){ _keepalive = ka;}

		bool clean() const {return _clean;}
		void clean(bool clean) { _clean = clean;}

		bool debug() const {return _debug;}
		void debug(bool debug) { _debug = debug;}

		qos quality() const { return _qos;}
		void quality(qos q) { _qos = q;}

		const string& id() const {return _id;}

		void id(const string& id) { _id = id;}

	private:
		typedef pair<string,std::function<void(string,string)> > mapped_function;
		typedef std::map<string,std::function<void(const string&,const string&)> > handler_map;
		
		void create(const uri& u);
		void find(const string& key, const string& value);
		const handler_map& handlers() const {return _handlers;}

		int		_port;
		string	_host;
		string	_topic;
		string	_username;
		string	_password;
		string  _id;
		int		_keepalive;
		bool	_clean;
		bool	_debug;
		qos		_qos;
		handler_map _handlers;
	};
}

