#pragma once
#include <cstdint>
#include <vector>
#include "qos.h"
#include "mosquitto.h"
namespace mosq
{
	class message
	{
	public:
		message(void);
		message(const mosquitto_message* msg);
		~message(void);

		uint16_t mid() const {return _mid;}
		qos quality() const {return _qos;}
		std::vector<uint8_t> payload() const {return _payload;}
		std::string topic() const {return _topic;}
		bool is_retained() const {return _retain;}

	private:
		uint16_t				_mid;
		qos						_qos;
		std::vector<uint8_t>	_payload;
		bool					_retain;
		std::string				_topic;
					
	};
}

