#pragma once

namespace mosq
{

	typedef enum 
	{
		successful = 0,
		no_memory = 1,
		protocol_error,
		invalid,
		no_connection,
		connection_refused,
		not_found,
		connection_lost,
		ssl_error,
		payload_size_error,
		not_supported,
		auth_error,
		acl_denied,
		unknown,
		check_errno

	} code_id;

	class return_code
	{
	public:
		return_code(code_id id);
		return_code(int id);
		return_code(void);

		const return_code& operator=(code_id id);
		const return_code& operator=(int id);

		bool operator==(const return_code& rc) const;
		bool operator==(int rc) const;
		bool operator==(const code_id rc) const;

		~return_code(void);

		code_id code()const {return _code;}
		void code(code_id id) {_code = id;};
		void code(int id) {_code = static_cast<code_id>(id);};
	private:
		code_id _code;
	};
}

