#ifndef STRINGTOKENIZER_H_
#define STRINGTOKENIZER_H_


#include <string>
#include <cstddef>

class StringTokenizer
{
public:
	StringTokenizer(const std::string& str, const std::string& delim=" \t\n\r\f", bool return_delims=false);
	bool hasMoreTokens();
	std::string nextToken();
private:
	const std::string m_str;
	const std::string m_delim;
	const bool m_return_delims;
	std::size_t m_cur_pos;
	std::string m_next_token;
};

#endif

