// mosquitto_cpp_client.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <sstream>
#include <process.h>
#include "mosquitto_factory.h"
#include "arguments.h"
using namespace mosq;

void on_connect(const mosquitto_base&, connection_result)
{

}

void on_disconnect(const mosquitto_base&, return_code)
{

}

void on_subscribe(const mosquitto_base&, uint16_t mid, vector<qos> granted_qos)
{

}

void on_message(const mosquitto_base&, const message& message)
{
	std::string payload;
	for(std::vector<uint8_t>::size_type i = 0; i < message.payload().size();i++)
	{
		payload.push_back(message.payload()[i]);
	}
	cout << "Topic: " << message.topic() << "/" << payload << endl;
}

int main(int argc, char* argv[])
{
	unique_ptr<arguments> args(new arguments(getpid()));
	
	if(argc == 2)
	{
		std::string s(argv[1]);
		uri u(s);
		args = std::move(unique_ptr<arguments>( new arguments(u,getpid())));
	}
	auto mq = mosquitto_factory::create(args->id(),args->clean());
	mq->on_connect.push_back(on_connect);
	mq->on_disconnect.push_back(on_disconnect);
	mq->on_message.push_back(on_message);
	mq->connect(args->host(),args->port(),args->keepalive());
	mq->subscribe(NULL,args->topic(),args->quality());
	if(args->debug())
		mq->initialise_log();
	mq->run();
	cout << "Press a key" << endl;
	char c;
	cin >> c;
	mq->disconnect();
	cout << "Press a key to quit" << endl;
	cin >> c;
	return 0;
}





